diff -urNX /home/leigh/.diffex prev_linux-2.4.21-rc3/arch/ppc/boot/prep/misc.c linux-2.4.21-rc3/arch/ppc/boot/prep/misc.c
--- prev_linux-2.4.21-rc3/arch/ppc/boot/prep/misc.c	2003-05-24 13:39:26.000000000 +0100
+++ linux-2.4.21-rc3/arch/ppc/boot/prep/misc.c	2003-05-24 13:39:41.000000000 +0100
@@ -110,16 +110,78 @@
 }
 #endif /* CONFIG_VGA_CONSOLE */
 
+void
+read_args(void)
+{
+	int timer = 0;
+	char *cp, ch;
+
+	puts("\nLinux/PPC load: ");
+	cp = cmd_line;
+	while ( *cp )
+		putc(*cp++);
+
+#ifdef INTERACTIVE_CONSOLE
+	/*
+	 * If they have a console, allow them to edit the command line.
+	 * Otherwise, don't bother wasting the five seconds.
+	 */
+	while (timer++ < 5*1000) {
+		if (tstc()) {
+			while ((ch = getc()) != '\n' && ch != '\r') {
+				/* Test for backspace/delete */
+				if (ch == '\b' || ch == '\177') {
+					if (cp != cmd_line) {
+						cp--;
+						puts("\b \b");
+					}
+				/* Test for ^x/^u (and wipe the line) */
+				} else if (ch == '\030' || ch == '\025') {
+					while (cp != cmd_line) {
+						cp--;
+						puts("\b \b");
+					}
+				} else {
+					*cp++ = ch;
+					putc(ch);
+				}
+			}
+			break;  /* Exit 'timer' loop */
+		}
+		udelay(1000);  /* 1 msec */
+	}
+	*cp = 0;
+#endif
+	puts("\n");
+}
+
+void
+get_of_args(void)
+{
+	int size;
+	int chosen;
+	char buf[256];
+
+	/* Get bootargs property of /chosen node */
+	if (of_finddevice("/chosen", &chosen))
+		goto out;
+
+	if (of_getprop(chosen, "bootargs", buf, sizeof(buf), &size))
+		goto out;
+
+	if (size > sizeof(cmd_buf))
+		size = sizeof(cmd_buf);
+
+	if (size > 1) /* includes null-terminator */
+		memcpy(cmd_buf, buf, size);
+out:
+}
+
 unsigned long
 decompress_kernel(unsigned long load_addr, int num_words, unsigned long cksum,
 		  RESIDUAL *residual, void *OFW_interface)
 {
-#ifdef INTERACTIVE_CONSOLE
-	int timer = 0;
-	char ch;
-#endif
 	extern unsigned long start;
-	char *cp;
 	/* Default to 32MiB memory. */
 	unsigned long TotalMemory = 0x02000000;
 	int dev_handle;
@@ -286,42 +348,14 @@
 	if (keyb_present)
 		CRT_tstc();  /* Forces keyboard to be initialized */
 
-	puts("\nLinux/PPC load: ");
-	cp = cmd_line;
-	while ( *cp )
-		putc(*cp++);
-#ifdef INTERACTIVE_CONSOLE
-	/*
-	 * If they have a console, allow them to edit the command line.
-	 * Otherwise, don't bother wasting the five seconds.
-	 */
-	while (timer++ < 5*1000) {
-		if (tstc()) {
-			while ((ch = getc()) != '\n' && ch != '\r') {
-				/* Test for backspace/delete */
-				if (ch == '\b' || ch == '\177') {
-					if (cp != cmd_line) {
-						cp--;
-						puts("\b \b");
-					}
-				/* Test for ^x/^u (and wipe the line) */
-				} else if (ch == '\030' || ch == '\025') {
-					while (cp != cmd_line) {
-						cp--;
-						puts("\b \b");
-					}
-				} else {
-					*cp++ = ch;
-					putc(ch);
-				}
-			}
-			break;  /* Exit 'timer' loop */
-		}
-		udelay(1000);  /* 1 msec */
-	}
-#endif
-	*cp = 0;
-	puts("\nUncompressing Linux...");
+	/* If we have OF then try to get args from there */
+	if (OFW_interface)
+		get_of_args();
+
+	/* Always give an opportunity to change the arguments */
+	read_args();
+
+ 	puts("Uncompressing Linux...");
 
 	/*
 	 * If we have OF, then we have deferred setting the MSR.
